VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "GW"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Base 0
Option Explicit
'code by Dimitri Furman <dfurman@cloud9.net>, unless otherwise noted
'last modified on 8/8/2000

Private mobjGWApp As Object
Private mobjGWAcct As Object

'late binding currently used
'early binding Dim's commented out throughout the module.
'GWCMA1.DLL is the GW typelib.
'tested with Groupwise 5.2.4 - 5.2.6

'Dim mobjGWApp As GroupwareTypeLibrary.Application
'Dim mobjGWAcct As GroupwareTypeLibrary.Account

Private mstrFromText As String 'GW will always append the account owner's name to this
Private mstrSubject As String 'up to 100 chars
Private mstrBodyText As String
Private mintPriority As Integer
Private mastrRecTo() As String 'mastrRecTo(0, i)=address; mastrRecTo(1, i)=display name
Private mastrRecCc() As String 'mastrRecCc(0, i)=address; mastrRecCc(1, i)=display name
Private mastrRecBc() As String 'mastrRecBc(0, i)=address; mastrRecBc(1, i)=display name
Private mastrFileAttachments() As String 'string array of paths
Private mastrNonResolved() As String 'array of non-resolved recipients if any

Private Const mconDefaultFolder = "Work In Progress" 'name of folder to create draft messages in if none other specified
Private Const mconEmailType = "NGW" 'should be something else for external(?) email
Private Const mconSystemAddrBookName = "Novell GroupWise Address Book" 'can be renamed?

'GW typelib's constants, defined here because of late binding being used
Private Const egwLow = 1
Private Const egwNormal = 2
Private Const egwHigh = 3
Private Const egwTo = 0
Private Const egwCC = 1
Private Const egwBC = 2
Private Const egwResolved = 3
Private Const egwDraft = 4
Private Const egwFile = 1
Private Const egwUser = 1
Private Const egwResource = 3

Private Const mconERR_GW_NOT_INSTALLED = vbObjectError Or 1000
Private Const mconERR_LOGIN_UNSUCCESSFUL = vbObjectError Or 1001
Private Const mconERR_BAD_MESSAGE_ID = vbObjectError Or 1002
Private Const mconERR_COULD_NOT_DELETE = vbObjectError Or 1003
Private Const mconERR_COULD_NOT_SEND = vbObjectError Or 1004
Private Const mconERR_NO_RECIPIENTS = vbObjectError Or 1005
Private Const mconERR_BAD_FOLDER_NAME = vbObjectError Or 1006
Private Const mconERR_BAD_REC_ARRAY = vbObjectError Or 1007
Private Const mconERR_BAD_ATTACHMENTS_ARRAY = vbObjectError Or 1008
Private Const mconERR_NO_TO_RECIPIENTS = vbObjectError Or 1009
Private Const mconERR_MSG_NOT_A_DRAFT = vbObjectError Or 1010
Private Const mconERR_COULD_NOT_PROXY = vbObjectError Or 1011

#Const VBA5 = False 'True for Access 97, False for VB or VBA6
#Const Access = False 'True for Access any version, False for VB
'For Access 2000 use VBA5=False, Access=True

#If Access Then
  Private mintErrTrapping As Integer
#End If

#If VBA5 Then
#Else
  Public Event GWStatus(ByVal strStatusMessage As String)
  Public Enum GWPriority
    LowPriority = egwLow
    NormalPriority = egwNormal
    HighPriority = egwHigh
  End Enum
#End If

'UNC code in this class was originally written by Terry Kreft
'and Dev Ashish.
'It is not to be altered or distributed,
'except as part of an application.
'You are free to use it in any application,
'provided the copyright notice is left unchanged.
'
' Original Code by Terry Kreft
' Modified by Dev Ashish
'
'Drive Types
Private Const DRIVE_UNKNOWN = 0
Private Const DRIVE_ABSENT = 1
Private Const DRIVE_REMOVABLE = 2
Private Const DRIVE_FIXED = 3
Private Const DRIVE_REMOTE = 4
Private Const DRIVE_CDROM = 5
Private Const DRIVE_RAMDISK = 6
' returns errors for UNC Path
Private Const ERROR_BAD_DEVICE = 1200&
Private Const ERROR_CONNECTION_UNAVAIL = 1201&
Private Const ERROR_EXTENDED_ERROR = 1208&
Private Const ERROR_MORE_DATA = 234
Private Const ERROR_NOT_SUPPORTED = 50&
Private Const ERROR_NO_NET_OR_BAD_PATH = 1203&
Private Const ERROR_NO_NETWORK = 1222&
Private Const ERROR_NOT_CONNECTED = 2250&
Private Const NO_ERROR = 0

Private Declare Function WNetGetConnection Lib "mpr.dll" Alias _
        "WNetGetConnectionA" (ByVal lpszLocalName As String, _
        ByVal lpszRemoteName As String, cbRemoteName As Long) As Long
Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias _
    "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, _
    ByVal lpBuffer As String) As Long
Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" _
    (ByVal nDrive As String) As Long


Private Sub GW_Status(strStatusMessage As String)
On Error Resume Next

#If VBA5 Then
  Select Case strStatusMessage
    Case vbNullString
      SysCmd acSysCmdClearStatus
    Case Else
      SysCmd acSysCmdSetStatus, strStatusMessage
  End Select
#Else
  RaiseEvent GWStatus(strStatusMessage)
#End If

End Sub


Private Property Get GWApp() As Object
On Error GoTo ErrHandler

If mobjGWApp Is Nothing Then _
  Set mobjGWApp = CreateObject("NovellGroupWareSession")

Set GWApp = mobjGWApp

ExitHere:
  Exit Property
  
ErrHandler:
  Select Case Err.Number
    Case 429
      Err.Raise mconERR_GW_NOT_INSTALLED, "GW::Initialize", "Groupwise is not installed or is not registered on this computer."
    Case Else
      Err.Raise Err.Number, Err.Source, Err.Description
  End Select
  Resume ExitHere
  
End Property



Private Function ValidateAttachArray(varAttachArray As Variant) As Boolean
Dim varTemp As Variant

On Error Resume Next
varTemp = varAttachArray(LBound(varAttachArray, 1))
'the array has to be exactly 1-dim
If Not (Err.Number > 0) Then ValidateAttachArray = True
Err.Clear

End Function

Private Function ValidateRecArray(varRecArray As Variant) As Boolean
On Error GoTo ErrHandler
Dim varTemp As Variant

On Error Resume Next
varTemp = varRecArray(LBound(varRecArray, 1), LBound(varRecArray, 2))
'the array has to be exactly 2-dim and ...
If Err.Number > 0 Then
  Err.Clear
  GoTo ExitHere
Else
  On Error GoTo ErrHandler
  If Not (LBound(varRecArray, 1) = 0 And _
    UBound(varRecArray, 1) = 1) Then GoTo ExitHere
  '... the first dimension has to be 0 To 1
  ValidateRecArray = True
End If

ExitHere:
  Exit Function

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere
  
End Function

Private Sub AddRecipients(objMsg As Object)
'adds recipients from arrays to a message, deletes those that cannot be resolved
On Error GoTo ErrHandler
Dim objRecipient As Object
'Dim objRecipient As GroupwareTypeLibrary.Recipient
Dim intCount As Integer, intCount2 As Integer

For intCount = 0 To UBound(mastrRecTo, 2)
  If Len(mastrRecTo(0, intCount)) > 0 Then 'there's an address
    Set objRecipient = objMsg.Recipients.Add(mastrRecTo(0, intCount), mconEmailType, egwTo)
    If Len(mastrRecTo(1, intCount)) > 0 Then objRecipient.DisplayName = mastrRecTo(1, intCount)
  Set objRecipient = Nothing
  End If
Next intCount
For intCount = 0 To UBound(mastrRecCc, 2)
  If Len(mastrRecCc(0, intCount)) > 0 Then 'there's an address
    Set objRecipient = objMsg.Recipients.Add(mastrRecCc(0, intCount), mconEmailType, egwCC)
    If Len(mastrRecCc(1, intCount)) > 0 Then objRecipient.DisplayName = mastrRecCc(1, intCount)
    Set objRecipient = Nothing
  End If
Next intCount
For intCount = 0 To UBound(mastrRecBc, 2)
  If Len(mastrRecBc(0, intCount)) > 0 Then 'there's an address
    Set objRecipient = objMsg.Recipients.Add(mastrRecBc(0, intCount), mconEmailType, egwBC)
    If Len(mastrRecBc(1, intCount)) > 0 Then objRecipient.DisplayName = mastrRecBc(1, intCount)
    Set objRecipient = Nothing
  End If
Next intCount
  
If UBound(mastrNonResolved) > 0 Then ReDim mastrNonResolved(0) 'in case .ResolveRecipients have been called before .SendMessage
For intCount = objMsg.Recipients.Count To 1 Step -1
  On Error Resume Next
  objMsg.Recipients(intCount).Resolve
  On Error GoTo ErrHandler
  If Not (objMsg.Recipients(intCount).Resolved = egwResolved) Then
    ReDim Preserve mastrNonResolved(intCount2)
    mastrNonResolved(intCount2) = objMsg.Recipients(intCount).EmailAddress
    intCount2 = intCount2 + 1
    objMsg.Recipients(intCount).Delete
  End If
Next intCount

ExitHere:
  On Error Resume Next
  Set objRecipient = Nothing
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Private Function fGetUNCPath(strDriveLetter As String) As String
    On Local Error GoTo fGetUNCPath_Err

    Dim Msg As String, lngReturn As Long
    Dim lpszLocalName As String
    Dim lpszRemoteName As String
    Dim cbRemoteName As Long
    lpszLocalName = strDriveLetter
    lpszRemoteName = String$(255, Chr$(32))
    cbRemoteName = Len(lpszRemoteName)
    lngReturn = WNetGetConnection(lpszLocalName, lpszRemoteName, _
                                       cbRemoteName)
    Select Case lngReturn
        Case ERROR_BAD_DEVICE
            Msg = "Error: Bad Device"
        Case ERROR_CONNECTION_UNAVAIL
            Msg = "Error: Connection Un-Available"
        Case ERROR_EXTENDED_ERROR
            Msg = "Error: Extended Error"
        Case ERROR_MORE_DATA
               Msg = "Error: More Data"
        Case ERROR_NOT_SUPPORTED
               Msg = "Error: Feature not Supported"
        Case ERROR_NO_NET_OR_BAD_PATH
               Msg = "Error: No Network Available or Bad Path"

        Case ERROR_NO_NETWORK
               Msg = "Error: No Network Available"
        Case ERROR_NOT_CONNECTED
               Msg = "Error: Not Connected"
        Case NO_ERROR
               ' all is successful...
    End Select
    If Len(Msg) Then
        MsgBox Msg, vbInformation
    Else
        fGetUNCPath = Left$(lpszRemoteName, cbRemoteName)
    End If
fGetUNCPath_End:
    Exit Function
fGetUNCPath_Err:
    MsgBox Err.Description, vbInformation
    Resume fGetUNCPath_End
End Function

Private Function fDriveType(strDriveName As String) As String
    Dim lngRet As Long
    Dim strDrive As String
    lngRet = GetDriveType(strDriveName)
    Select Case lngRet
        Case DRIVE_UNKNOWN 'The drive type cannot be determined.
            strDrive = "Unknown Drive Type"
        Case DRIVE_ABSENT 'The root directory does not exist.
            strDrive = "Drive does not exist"
        Case DRIVE_REMOVABLE 'The drive can be removed from the drive.
            strDrive = "Removable Media"
        Case DRIVE_FIXED 'The disk cannot be removed from the drive.
            strDrive = "Fixed Drive"
        Case DRIVE_REMOTE  'The drive is a remote (network) drive.
            strDrive = "Network Drive"
        Case DRIVE_CDROM 'The drive is a CD-ROM drive.
            strDrive = "CD Rom"
        Case DRIVE_RAMDISK 'The drive is a RAM disk.
            strDrive = "Ram Disk"
    End Select
    fDriveType = strDrive
End Function


Public Function IsFolder(strFolderID) As Boolean
On Error GoTo ErrHandler
Dim objFld As Object
Dim strTemp As String

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::IsFolder", "Could not login to Groupwise."

On Error Resume Next
Set objFld = mobjGWAcct.GetFolder(strFolderID)
On Error GoTo ErrHandler
'will get an object here if strFolderID is a valid MessageID

If Not (objFld Is Nothing) Then
  On Error Resume Next
  strTemp = objFld.Name 'a folder has a name, a message doesn't
  On Error GoTo ErrHandler
  If Len(strTemp) > 0 Then IsFolder = True
End If

ExitHere:
  On Error Resume Next
  Set objFld = Nothing
  Exit Function
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Function IsMessage(strMessageID) As Boolean
On Error GoTo ErrHandler
Dim objMsg As Object

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::IsMessage", "Could not login to Groupwise."

On Error Resume Next
Set objMsg = mobjGWAcct.GetMessage(strMessageID)
On Error GoTo ErrHandler

IsMessage = Not (objMsg Is Nothing)

ExitHere:
  On Error Resume Next
  Set objMsg = Nothing
  Exit Function
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Sub Reset()
'resets all message properties, prepares for a new message
On Error GoTo ErrHandler

mstrFromText = vbNullString
mstrSubject = vbNullString
mstrBodyText = vbNullString
mintPriority = egwNormal
InitArrays

GW_Status vbNullString

ExitHere:
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Public Sub ResolveRecipients(strMessageID As String)
'this *may* be called before SendMessage to see if there are any
'non-resolving recipients. If there are, get them from .NonResolved property
On Error GoTo ErrHandler
Dim objMsg As Object

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::ResolveRecipients", "Could not login to Groupwise."

Set objMsg = mobjGWAcct.GetMessage(strMessageID)
If objMsg Is Nothing Then
  Err.Raise mconERR_COULD_NOT_SEND, "GW::ResolveRecipients", "Could not get MessageID '" & strMessageID & "'."
  GoTo ExitHere
End If

AddRecipients objMsg

ExitHere:
  On Error Resume Next
  Set objMsg = Nothing
  Exit Sub
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Public Function ValidateEmail(strEmail As String) As Boolean
'attempts to return True only if strEmail is a syntactically valid email address
On Error GoTo ErrHandler

If (strEmail Like "*?@?*.?*") And Not (strEmail Like "*@*@*") And Not (strEmail Like "*..*") And Not (strEmail Like "* *") And Not (strEmail Like "*.") Then _
  ValidateEmail = True

ExitHere:
  Exit Function

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Property Let BodyText(strBodyText As String)
  
If Len(strBodyText) > 0 Then mstrBodyText = strBodyText & vbCrLf
'GW might cut off the last word without vbCrLf

End Property

Private Function ConvertToUNC(strFilePath As String) As String
On Error GoTo ErrHandler
Dim strDrive As String
Dim strDrivelessPath As String
Dim strUNCPath As String

If Not (Len(strFilePath) >= 2) Then 'at least need drive
  ConvertToUNC = strFilePath
  GoTo ExitHere
End If

If Not (StrComp(fDriveType(Left$(strFilePath, 2)), "Network Drive", vbTextCompare) = 0) Then
  ConvertToUNC = strFilePath
  GoTo ExitHere
End If

strDrive = Left$(strFilePath, 2)
strDrivelessPath = Mid$(strFilePath, 3)

strUNCPath = fGetUNCPath(strDrive)
strUNCPath = Left$(Trim$(strUNCPath), Len(Trim$(strUNCPath)) - 1)
strUNCPath = strUNCPath & strDrivelessPath

If Len(Dir(strUNCPath, vbNormal) & Dir(strUNCPath, vbDirectory) & vbNullString) > 0 Then
  ConvertToUNC = strUNCPath
Else
  ConvertToUNC = strFilePath
End If

ExitHere:
  Exit Function

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Function CreateFolder(strFolderName As String, Optional blnInCabinet As Boolean) As Variant
'creates a folder under root account or under Cabinet folder if blnInCabinet, returns FolderID
On Error GoTo ErrHandler
Dim objParentFlds As Object
Dim objFolder As Object
'Dim objParentFlds As GroupwareTypeLibrary.Folders
'Dim objFolder As GroupwareTypeLibrary.Folder

GW_Status "Creating folder"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::CreateFolder", "Could not login to Groupwise."

If Not (Len(strFolderName) > 0) Then Err.Raise mconERR_BAD_FOLDER_NAME, "GW::CreateFolder", "Invalid folder name: '" & strFolderName & "'"

If blnInCabinet Then
  Set objParentFlds = mobjGWAcct.Cabinet.Folders
Else
  Set objParentFlds = mobjGWAcct.AllFolders
End If

Set objFolder = objParentFlds.Add(strFolderName)
CreateFolder = objFolder.FolderID

mobjGWAcct.Refresh

ExitHere:
  On Error Resume Next
  Set objFolder = Nothing
  Set objParentFlds = Nothing
  GW_Status vbNullString
  Exit Function

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Sub DeleteMessage(strMessageID As String, Optional blnPurge As Boolean)
'sends a message to Trash by MessageID, no prompt
'optionally purges the message from message store
On Error GoTo ErrHandler
Dim objMsg As Object
Dim objTrashEntries As Object
'Dim objMsg As GroupwareTypeLibrary.Message
'Dim objTrashEntries As GroupwareTypeLibrary.TrashEntries
Dim lngCount As Long

GW_Status "Deleting message"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::DeleteMessage", "Could not login to Groupwise."

Set objMsg = mobjGWAcct.GetMessage(strMessageID)
If objMsg Is Nothing Then
  Err.Raise mconERR_COULD_NOT_DELETE, "GW::DeleteMessage", "Could not delete MessageID '" & strMessageID & "'."
  GoTo ExitHere
End If

objMsg.Delete
objMsg.Parent.Refresh

If blnPurge Then
  Set objTrashEntries = mobjGWAcct.Trash.TrashEntries
  For lngCount = objTrashEntries.Count To 1 Step -1 'assume that the message being purged is likely to be at the top of the collection, so it's faster to go from the top
    If StrComp(objTrashEntries(lngCount).Message.MessageID, objMsg.MessageID, vbTextCompare) = 0 Then
      objTrashEntries(lngCount).Delete 'purge
      Exit For
    End If
  Next lngCount
End If

Me.RefreshAcct

ExitHere:
  On Error Resume Next
  Set objMsg = Nothing
  Set objTrashEntries = Nothing
  GW_Status vbNullString
  Exit Sub

ErrHandler:
  Select Case Err.Number
    Case -2147352567
      Err.Raise mconERR_BAD_MESSAGE_ID, "GW::DeleteMessage", "Invalid MessageID '" & strMessageID & "'."
    Case Else
      Err.Raise Err.Number, Err.Source, Err.Description
  End Select
  Resume ExitHere

End Sub

Public Property Let FileAttachments(varFileAttachments As Variant)
'accepts an array of file paths or single path, converts to UNC if network path
'no wildcards
On Error GoTo ErrHandler
Dim intCount As Integer
Dim intLBound As Integer
Dim strPath As String

If Not IsArray(varFileAttachments) Then 'assume single path submitted
  ReDim mastrFileAttachments(0)
  strPath = ConvertToUNC(varFileAttachments & vbNullString)
  If Len(Dir(strPath) & vbNullString) > 0 Then mastrFileAttachments(0) = strPath
Else
  If Not ValidateAttachArray(varFileAttachments) Then Err.Raise mconERR_BAD_ATTACHMENTS_ARRAY, "GW::FileAttachments", "Invalid attachments array."
  intLBound = LBound(varFileAttachments)
  For intCount = intLBound To UBound(varFileAttachments)
    strPath = ConvertToUNC(varFileAttachments(intCount - intLBound) & vbNullString)
    If Len(Dir(strPath) & vbNullString) > 0 Then
      ReDim Preserve mastrFileAttachments(intCount - intLBound) 'make it 0-based
      mastrFileAttachments(intCount - intLBound) = strPath
      'might get a ZLS array element here, that's OK
    End If
  Next intCount
End If

ExitHere:
  Exit Property

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property

Public Property Let FromText(strFromText As String)
  mstrFromText = strFromText & Space(1)
End Property


Private Sub InitArrays()
On Error GoTo ErrHandler

Erase mastrRecTo, mastrRecBc, mastrRecBc, mastrFileAttachments, mastrNonResolved

ReDim mastrRecTo(1, 0)
ReDim mastrRecCc(1, 0)
ReDim mastrRecBc(1, 0)
ReDim mastrFileAttachments(0)
ReDim mastrNonResolved(0)

ExitHere:
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Public Property Get NonResolved() As Variant
'1-dim. array of non-resolved addresses for To, Cc, and Bc lists, if any; otherwise Null
'available after .AddRecipients
On Error GoTo ErrHandler

If Len(mastrNonResolved(0)) > 0 Then
  NonResolved = mastrNonResolved
Else
  NonResolved = Null
End If

ExitHere:
  Exit Property
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property

Public Property Get AcctOwner() As String
On Error GoTo ErrHandler
  
If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::AcctOwner", "Could not login to Groupwise."
  
AcctOwner = mobjGWAcct.Owner

ExitHere:
  Exit Property
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property

#If VBA5 Then
Public Property Let Priority(strPriority As String)
'priority doesn't stick to a draft message and is reset to Standard after Message.Refresh
On Error GoTo ErrHandler

Select Case LCase$(strPriority)
  Case "low"
    mintPriority = egwLow
  Case "high"
    mintPriority = egwHigh
  Case Else
    mintPriority = egwNormal
End Select
  
ExitHere:
    Exit Property
    
ErrHandler:
    Err.Raise Err.Number, Err.Source, Err.Description
    Resume ExitHere
  
End Property

#Else
Public Property Let Priority(ePriority As GWPriority)
'priority doesn't stick to a draft message and is reset to Standard after Message.Refresh
On Error GoTo ErrHandler

mintPriority = ePriority

ExitHere:
  Exit Property
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property
#End If

Public Property Let RecBc(varRecBc As Variant)
'accepts an array of Bc: recipients: varRecBc(0, i)=address; varRecBc(1, i)=display name
'or a single address
On Error GoTo ErrHandler
Dim intCount As Integer
Dim intLBound As Integer

If Not IsArray(varRecBc) Then 'assume single address with no display name
  ReDim mastrRecBc(1, 0)
  mastrRecBc(0, 0) = varRecBc & vbNullString
Else
  If Not ValidateRecArray(varRecBc) Then Err.Raise mconERR_BAD_REC_ARRAY, "GW::RecBc", "Invalid recipients array."
  intLBound = LBound(varRecBc, 2)
  For intCount = intLBound To UBound(varRecBc, 2)
    ReDim Preserve mastrRecBc(1, intCount - intLBound) 'make it 0-based
    mastrRecBc(0, intCount - intLBound) = CStr(varRecBc(0, intCount) & vbNullString)
    mastrRecBc(1, intCount - intLBound) = CStr(varRecBc(1, intCount) & vbNullString)
  Next intCount
End If

ExitHere:
  Exit Property

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere
  
End Property

Public Property Let RecCc(varRecCc As Variant)
'accepts an array of Cc: recipients: varRecCc(0, i)=address; varRecCc(1, i)=display name
'or a single address
On Error GoTo ErrHandler
Dim intCount As Integer
Dim intLBound As Integer

If Not IsArray(varRecCc) Then 'assume single address with no display name
  ReDim mastrRecCc(1, 0)
  mastrRecCc(0, 0) = varRecCc & vbNullString
Else
  If Not ValidateRecArray(varRecCc) Then Err.Raise mconERR_BAD_REC_ARRAY, "GW::RecCc", "Invalid recipients array."
  intLBound = LBound(varRecCc, 2)
  For intCount = intLBound To UBound(varRecCc, 2)
    ReDim Preserve mastrRecCc(1, intCount - intLBound) 'make it 0-based
    mastrRecCc(0, intCount - intLBound) = CStr(varRecCc(0, intCount) & vbNullString)
    mastrRecCc(1, intCount - intLBound) = CStr(varRecCc(1, intCount) & vbNullString)
  Next intCount
End If

ExitHere:
  Exit Property
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere
  
End Property

Public Property Let RecTo(varRecTo As Variant)
'accepts an array of To: recipients: varRecTo(0, i)=address; varRecTo(1, i)=display name
'or a single address
On Error GoTo ErrHandler
Dim intCount As Integer
Dim intLBound As Integer

If Not IsArray(varRecTo) Then 'assume single address with no display name
  ReDim mastrRecTo(1, 0)
  mastrRecTo(0, 0) = varRecTo & vbNullString
Else
  If Not ValidateRecArray(varRecTo) Then Err.Raise mconERR_BAD_REC_ARRAY, "GW::RecTo", "Invalid recipients array."
  intLBound = LBound(varRecTo, 2)
  For intCount = intLBound To UBound(varRecTo, 2)
    ReDim Preserve mastrRecTo(1, intCount - intLBound) 'make it 0-based
    mastrRecTo(0, intCount - intLBound) = CStr(varRecTo(0, intCount) & vbNullString)
    mastrRecTo(1, intCount - intLBound) = CStr(varRecTo(1, intCount) & vbNullString)
  Next intCount
End If
  
ExitHere:
  Exit Property

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere
  
End Property

Public Sub RefreshAcct()
On Error GoTo ErrHandler

GW_Status "Refreshing account"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::RefreshAcct", "Could not login to Groupwise."

mobjGWAcct.Refresh 'supposed to refresh all subordinates

ExitHere:
  GW_Status vbNullString
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Public Function SendMessage(strMessageID As String) As Boolean
'sends an existing draft message by MessageID
'need at least one To: recipient
'the draft message (strMessageID) goes to Trash if send successful,
'otherwise stays in the folder it was originally created (Work In Progress).
'the same message can be sent again, even if in Trash, unless
'.DeleteMessage( ,True) is used after the first send
On Error GoTo ErrHandler
Dim objMsg As Object
'Dim objMsg As GroupwareTypeLibrary.Message
Dim intCount As Integer
Dim blnError As Boolean, blnTo As Boolean

GW_Status "Sending message"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::SendMessage", "Could not login to Groupwise."

On Error Resume Next
Set objMsg = mobjGWAcct.GetMessage(strMessageID)
On Error GoTo ErrHandler
If objMsg Is Nothing Then
  Err.Raise mconERR_COULD_NOT_SEND, "GW::SendMessage", "Could not get MessageID '" & strMessageID & "'."
  GoTo ExitHere
End If

If Not (objMsg.BoxType = egwDraft) Then Err.Raise mconERR_MSG_NOT_A_DRAFT, "GW::SendMessage", "MessageID '" & strMessageID & "' is not a draft message."

AddRecipients objMsg
  
If Not (objMsg.Recipients.Count > 0) Then
  Err.Raise mconERR_NO_RECIPIENTS, "GW::SendMessage", "Could not send message, no valid recipients defined for MessageID '" & strMessageID & "'."
  GoTo ExitHere
Else 'make sure there's at least one To recipient left after possible deletions
  For intCount = 1 To objMsg.Recipients.Count
    If objMsg.Recipients(intCount).TargetType = egwTo Then
      blnTo = True
      Exit For
    End If
  Next intCount
End If

If Not blnTo Then
  Err.Raise mconERR_NO_TO_RECIPIENTS, "GW::SendMessage", "Could not send message, no valid 'To:' recipients defined for MessageID '" & strMessageID & "'."
  GoTo ExitHere
End If

objMsg.Priority = mintPriority

objMsg.Send
SendMessage = True

ExitHere:
  On Error Resume Next
  Set objMsg = Nothing
  GW_Status vbNullString
  Exit Function

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Function

Public Property Let Subject(strSubject As String)
  mstrSubject = Left$(strSubject, 100)
End Property

Private Sub Class_Initialize()
On Error GoTo ErrHandler

#If Access Then
  mintErrTrapping = Application.GetOption("Error Trapping")
  Application.SetOption "Error Trapping", 2 'not effective in Class_Initialize
#End If

InitArrays
mintPriority = egwNormal

ExitHere:
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub


Private Sub Class_Terminate()
On Error Resume Next

Erase mastrRecTo, mastrRecBc, mastrRecBc, mastrFileAttachments, mastrNonResolved

Set mobjGWAcct = Nothing
mobjGWApp.Quit 'needed?
Set mobjGWApp = Nothing

#If Access Then
  Application.SetOption "Error Trapping", mintErrTrapping
#End If

GW_Status vbNullString

End Sub

Public Sub Login(Optional strLoginName As String, Optional strPassword As String)
On Error GoTo ErrHandler

GW_Status "Logging in to Groupwise"

Set mobjGWAcct = GWApp.Login(StrConv(strLoginName, vbUpperCase), , strPassword)

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::Login", "Could not login to Groupwise."

InitArrays

ExitHere:
  GW_Status vbNullString
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub
Public Function CreateMessage(Optional strFolder As String) As Variant
'creates a draft message (in specified folder if any) and returns GW MessageID on success
'if folder doesn't exist, will create it under root; if need it anyplace else, use .CreateFolder() beforehand
'recipients and priority cannot be saved with a draft message, have to add them immediately before send
On Error GoTo ErrHandler
Dim objMsg As Object
'Dim objMsg As GroupwareTypeLibrary.Message
Dim strTemp As String
Dim intCount As Integer

GW_Status "Creating draft message"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::CreateMessage", "Could not login to Groupwise."

If Len(strFolder) > 0 Then 'make sure that the folder exists
  On Error Resume Next
  strTemp = mobjGWAcct.AllFolders.ItemByName(strFolder).Name
  Err.Clear
  On Error GoTo ErrHandler
  If Len(strTemp) > 0 Then 'it does
    Set objMsg = mobjGWAcct.AllFolders.ItemByName(strFolder).Messages.Add("GW.MESSAGE.MAIL", egwDraft)
  Else 'create folder
    Set objMsg = mobjGWAcct.AllFolders.Item(CStr(CreateFolder(strFolder))).Messages.Add("GW.MESSAGE.MAIL", egwDraft)
  End If
Else
  Set objMsg = mobjGWAcct.AllFolders.ItemByName(mconDefaultFolder).Messages.Add("GW.MESSAGE.MAIL", egwDraft)
End If
If objMsg Is Nothing Then GoTo ExitHere

If Len(mstrSubject) > 0 Then
  objMsg.Subject = mstrSubject
Else
  objMsg.Subject = Space(1) 'otherwise GW will use first 100 chars of msg body
End If
If Len(mstrBodyText) > 0 Then objMsg.BodyText = mstrBodyText
If Len(mstrFromText) > 0 Then objMsg.FromText = mstrFromText
For intCount = 0 To UBound(mastrFileAttachments)
  If Len(mastrFileAttachments(intCount)) > 0 Then
    objMsg.Attachments.Add mastrFileAttachments(intCount), egwFile
  End If
Next intCount
objMsg.Refresh
CreateMessage = objMsg.MessageID

ExitHere:
  On Error Resume Next
  Set objMsg = Nothing
  GW_Status vbNullString
  Exit Function
  
ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere
  
End Function


Public Property Get AvailableProxies(Optional blnRefresh As Boolean) As Variant
'slow
'may show 'access denied' errors on POA console with C/S access
On Error GoTo ErrHandler
Static varProxies As Variant
Dim objAccount As Object
Dim objAddrBookEntry As Object
'Dim objAccount As GroupwareTypeLibrary.Account
'Dim objAddrBookEntry As GroupwareTypeLibrary.AddressBookEntry

GW_Status "Getting Proxies"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::AvailableProxies", "Could not login to Groupwise."

If IsEmpty(varProxies) Or blnRefresh Then 'do it once, then cache the array
  For Each objAddrBookEntry In mobjGWAcct.AddressBooks(mconSystemAddrBookName).AddressBookEntries
    'attempt to proxy to each address in the system addr. book
    'otherwise the ProxyAccounts collection is empty
    If objAddrBookEntry.ObjType = egwUser Or objAddrBookEntry.ObjType = egwResource Then
      On Error Resume Next
      GWApp.Proxy objAddrBookEntry.EmailAddress
      On Error GoTo ErrHandler
    End If
  Next objAddrBookEntry
  
  'get proxy addresses
  ReDim varProxies(0)
  For Each objAccount In GWApp.ProxyAccounts
    varProxies(UBound(varProxies)) = objAccount.Owner
    ReDim Preserve varProxies(UBound(varProxies) + 1)
  Next objAccount
  
  If Len(varProxies(0) & vbNullString) > 0 Then
    ReDim Preserve varProxies(UBound(varProxies) - 1)
  Else
    varProxies = Null
  End If
End If

AvailableProxies = varProxies

ExitHere:
  GW_Status vbNullString
  Exit Property

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property

Public Sub Proxy(strAddress As String)
On Error GoTo ErrHandler
Static objGWAcct As Object
'Static objGWAcct As GroupwareTypeLibrary.Account

GW_Status "Proxying"

If mobjGWAcct Is Nothing Then Err.Raise mconERR_LOGIN_UNSUCCESSFUL, "GW::Proxy", "Could not login to Groupwise."

Set objGWAcct = Nothing
On Error Resume Next
Set objGWAcct = GWApp.Proxy(strAddress)
On Error GoTo ErrHandler

If objGWAcct Is Nothing Then
  Err.Raise mconERR_COULD_NOT_PROXY, "GW::Proxy", "Could not proxy to specified address."
Else
  Set mobjGWAcct = objGWAcct
End If

ExitHere:
  GW_Status vbNullString
  Exit Sub

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Sub

Public Property Get IsAcctProxied() As Boolean
On Error GoTo ErrHandler

IsAcctProxied = mobjGWAcct.Proxied

ExitHere:
  Exit Property

ErrHandler:
  Err.Raise Err.Number, Err.Source, Err.Description
  Resume ExitHere

End Property




